<template>
  <section code-editor>
    <footerMounter name="test" />
    <v-tabs v-model="selectedFileNum" height="34">
      <v-tab v-for="filename in tabs" :key="filename">{{
        toTabName(filename)
      }}</v-tab>
    </v-tabs>
    <pre ref="ace"></pre>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Watch } from "vue-property-decorator";
import { edit as makeEditor, Editor, Annotation } from "brace";
import { stores } from "../store";
import "brace/mode/json";
import "brace/theme/chrome";
import axios from "../lib/axios";
import { GLSync } from "../lib/goldenlayout/glSync";
import { PSAPIData } from "../store/modules/prescales";
import { Container } from "golden-layout";
import footerMounter from "../components/footerMounter.vue";

interface AnnotationSet {
  [filename: string]: Annotation[];
}

@Component({
  components: {
    footerMounter,
  },
})
export default class extends Vue {
  private editor!: Editor;
  private container!: Container;
  private updateDebounce = 0;

  get tabs() {
    return Object.keys(stores.prescales.json) as (keyof PSAPIData)[];
  }

  private toTabName(filename: string) {
    const pieces = filename.split(".");
    pieces.length = pieces.length - 1; // remove extension
    let tabname = pieces.join(" ");
    tabname = tabname.replace("l1", "L1").replace("hlt", "HLT");
    return tabname;
  }

  @GLSync()
  private selectedFileNum = -1;

  private lastSelectedFile = "";
  private allAnnotations: AnnotationSet = {};

  get selectedFile(): keyof PSAPIData {
    return this.tabs[this.selectedFileNum];
  }

  @Watch("selectedFileNum")
  private setAceContent(newval: number, oldval: number) {
    this.lastSelectedFile = this.tabs[oldval];

    this.updateValue();
  }

  private updateValue() {
    this.editor.setValue(stores.prescales.json[this.selectedFile], -1);
  }

  public async validate(): Promise<void> {
    const s = this.editor.getSession();
    s.clearAnnotations();
    const response = await axios.post({
      url: "/api/v1/external/vet",
      data: {
        arguments: {},
      },
      // // responseType: 'text', https://github.com/axios/axios/issues/907
      transformResponse: [r => r],
    });

    this.allAnnotations = (response.data as string)
      .split("\n")
      .filter(s => s)
      .map(s => JSON.parse(s))
      .filter(entry => entry.type == "commandOutput")
      .map(e => ({
        annotation: this.toAnnotation(e.data.Data),
        filename: e.data.filename,
      }))
      .reduce((result, item) => {
        if (result[item.filename]) {
          result[item.filename].push(item.annotation);
        } else {
          result[item.filename] = [item.annotation];
        }
        return result;
      }, {} as AnnotationSet);
    s.setAnnotations(this.allAnnotations[this.selectedFile] || []);
  }

  public async sendAndValidate(): Promise<void> {
    const s = this.editor.getSession();
    const filename = this.selectedFile;
    const val = s.getValue();

    if (stores.prescales.json[filename] == val) {
      s.setAnnotations(this.allAnnotations[this.selectedFile] || []);
      return;
    }

    await this.$store.dispatch("setJSONFile", {
      key: filename,
      data: val,
    });

    await this.validate();
  }

  private toAnnotation(data: {
    line: number;
    col: number;
    message: string;
  }): Annotation {
    return {
      row: data.line ? data.line - 1 : 0,
      column: data.col || 0,
      type: "error",
      text: data.message,
    };
  }

  public async mounted() {
    // TODO move validation logic to store, access with getter
    const e = (this.editor = makeEditor(this.$refs.ace as HTMLElement));
    const s = e.getSession();
    e.$blockScrolling = Infinity;
    e.setTheme("ace/theme/chrome");
    s.setMode("ace/mode/json");
    s.setUseWorker(false); // disable built-in validator
    // this.setAceContent() // don't uncomment, selectedfile not set yet, wait for watcher

    s.on("change", () => {
      clearTimeout(this.updateDebounce);
      this.updateDebounce = setTimeout(this.sendAndValidate.bind(this), 1000);
    });

    stores.root.subscribe(mutation => {
      if (mutation.type == "_setLocalJSON") {
        const fileContent = mutation.payload[this.selectedFile];

        if (s.getValue() != fileContent) {
          s.setValue(fileContent);
        }
      }
      if (mutation.type == "getRemoteJSON") {
        this.updateValue();
      }
    });
    this.validate();
  }
}
</script>

<style scoped lang="scss">
[code-editor] {
  height: 100%;
  display: flex;
  flex-direction: column;
  flex: 1;

  .v-tabs {
    flex: 0;
  }

  pre {
    margin: 0;
    flex: 1;
  }
}
</style>
